import lang.stride.*;
import java.util.*;
import greenfoot.*;

public class Asteroid extends Actor
{
    protected int dieCounter = 20; // wie lange sieht man die Explosion
    protected boolean wurdeGetroffen = false;
    protected Weltraum m;
    private int geschwindigkeit = 2;
    private GreenfootImage gfiAsteroid = this.getImage();
    private int aGroesseX = this.gfiAsteroid.getWidth();
    private int aGroesseY = this.gfiAsteroid.getHeight();
    public Asteroid() {

    }

    public void addedToWorld(World w) {
                this.m = (Weltraum)w;

        int skalierungsfaktor = Greenfoot.getRandomNumber(3) + 1;
        this.aGroesseX = (int)this.aGroesseX/skalierungsfaktor;
        this.aGroesseY = (int)this.aGroesseY/skalierungsfaktor;
        this.gfiAsteroid.scale(this.aGroesseX, this.aGroesseY);
        this.setLocation(Greenfoot.getRandomNumber(w.getWidth() - 100) + 50, Greenfoot.getRandomNumber(w.getHeight() - 250) + 50);
    }

    public void act() {
        this.bewegen();
         if(this.isTouching(Rakete.class)) {
            this.wurdeGetroffen = true;
            this.setImage("explosiongelb_100.png");
            Sound.play("EXPLOSION");
            this.dieCounter = 20;
            this.m.asteroidenAbschussRegistrieren();
            this.removeTouching(Rakete.class);

        }
        if(this.wurdeGetroffen) {
            this.dieCounter--;
            if(this.dieCounter <= 0) {
                this.getWorld().removeObject(this);
                return;
            }

        }
        this.dieCounter--;
    }

    public void bewegen() {
        this.move(this.geschwindigkeit);
        if(this.isAtEdge()) {
            this.geschwindigkeit *= -1;
            this.move(this.geschwindigkeit);
        }

    }
}
